function x = ChineseRemainderSolnShow(bVec,nVec)
%x = ChineseRemainderSolnShow(bVec,nVec)
% Inputs: bVec, nVec =  two same-sized vectors of integers, where
% n(i)'s are pairwise relatively prime positive integers.
% Output:  x = the unique integer solution mod(product(nVec)) of the system
% of congruencies:
%   x= a(1) mod n(1)
%   x= a(2) mod n(2)
%   ...
%   x= a(k) mod n(k)
% as determined by the algorithm in the existence proof of the Chinese
% remainder theorem.  In contrast with the related M-file ChineseRemainderSoln,
% this program will show some key intermediate steps.
k=length(bVec);
N=prod(nVec);
fprintf('The solution obtained will be unique modulo N = %d.\r', N)
x=0; %initialize x
for i=1:k
   ei =  ModInv(N/nVec(i),nVec(i));
   fprintf('The inverse of N/NVec_%d (mod nVec_%d) is e_%d = %d,\r', i, i, i, ei)
   term = bVec(i)*(N/nVec(i))*ei;
   fprintf('  and the corresponding term of the solution x is (bVec_%d)(e_%d)(N/nVec_%d) = %d.\r', i,i,i,term) 
   x=x+term;
   x=mod(x,N);
end  
