function c = FastExpShow(a,b,n)
% c = FastExpShow(a,b,n)
% Input:  a, b, < n positive integers, n = the modulus
% Output: c = a^b (mod n) 
% Program uses the fast exponentiation method to calculate c = a^b (mod n).  
% Beginning with factor = a^1: 
% on each pass, it is determined whether this is a desired factor.  If so, then 
% it is multiplied into a variable containing a cumulative product of desired 
% factors.  Then the factor is squared, and the process repeated.

exp = b;
c = 1;
factor = a;
fprintf('The binary expansion of the exponent is: \r')
int2bin(b)
fprintf('Initialize cummultative product: a = %d\r', c)
fprintf('Initialize cummulative square as a (mod  %d) : s = %d\r', n,mod(factor,n))
fprintf('We now run through the digits of the binary expansion, from right to left,\r')
fprintf('with index K = 0 corresponding to rightmost digit:\r')
K = 0;
while(exp > 0)
    binDigit = mod(exp,2);
    fprintf('\rWith K = %d, the corresponding binary digit of the exponent is %d,\r',K, binDigit)
    if binDigit == 0
        fprintf('so we do not multiply the cumulative product with s.\r')
    else
        fprintf('so we multiply the cumulative product with s to get %d\r', c*factor)
        c = mod(c .* factor,n);
        fprintf('and convert this (mod %d):a = %d.\r', n, c)
    end
    exp = floor(exp/2);
    factor = mod(factor.*factor,n);
    fprintf('We update cummulative square (mod  %d) for the next iteration : s= %d\r', n,mod(factor,n))
    K = K+1;
end
