function vec = int2basebShow(n,b,k)
%  vec = int2basebShow(n,b)
%This function converts a nonnegative integer n, to a vector of 0s and 1s
%that represents its base b expansion.  The optional third input variable
%k is a nonnegative integer representing the length of the output vector if
%one wishes to specify this, with a string of 0s appended to fill in extra 
%space.  An error message will result if k is not sufficiently large.
%In this Show version, all intermediate steps of Algorithm 6.1 will be
%shown.
vec=[];
if n==0, vec = [0];
else
    fprintf('Initialize R = n = %d.\r', n)
    for j=floor(log2(n)/log2(b)):-1:0
        if b^j<=n,
            fprintf('The largest integer k such that %d^k is <= R is %d.\r', b,j)
            c = floor(n/b^j);
            fprintf('The corresponding coefficient c(%d) is %d.\r', j,c) 
             n=n-c*b^j; vec=[vec c];
             fprintf('Update R -> R - c(%d)%d^%d = %d.\r', j,b,j,n)
        else vec=[vec 0];
        end
    end
end
fprintf('We form the vector of coefficients, filling in missing ones with zeros:\r')
vec
if nargin>2
    if length(vec)>k, error('vector length parameter is too small')
        else, vec=[zeros(1,k-length(vec)),vec];
    end
end
